#import <AppKit/AppKit.h>
#import <stdlib.h>                	// For rand(), srand().
#import <libc.h>
#import "Anima.h"

#define INITRAND   srand((unsigned)(fabs(fmod([NSDate timeIntervalSinceReferenceDate], (double)INT_MAX))))
#define RADIO 150

@implementation Anima

- (id)initWithFrame:(NSRect)rect {
    [super initWithFrame:rect];
    [self allocateGState];
    NSBundle *bundle = [NSBundle bundleForClass:[Anima class]];

    paisaje = [[NSImage allocWithZone:[self zone]]
             initByReferencingFile:[bundle pathForImageResource:@"paisaje.tiff"]];
    pajarito[0] = [[NSImage allocWithZone:[self zone]]
             initWithContentsOfFile:[bundle pathForImageResource:@"pajarito1.tiff"]];
    pajarito[1] = [[NSImage allocWithZone:[self zone]]
             initWithContentsOfFile:[bundle pathForImageResource:@"pajarito2.tiff"]];
    np = vuela = 0; 
    v.x = 20; 
    v.y = 0; 
    theta = 0; 

    INITRAND;
    running = NO;
    return self;
}

- (void)dealloc {
    if (running) {
        [pajaritoTimer invalidate];
        [pajaritoTimer release];
    }
    [super dealloc]; 
}

- (void)drawRect:(NSRect)rects
{
   NSPoint o; 

   o.x = o.y = 0; 
   [paisaje compositeToPoint:o operation:NSCompositeCopy];

   if (vuela) {
      [pajarito[np] compositeToPoint:v operation: NSCompositeXOR]; 
                                            // NSCompositeSourceOver
   }
}

- (void)animo:(id)sender
{
    vuela = 1; 
    v.x = v.y = 20;
    for (v.x = 50; v.x<460; v.x+=8) { 
       v.y = 0.0042*((v.x-50)*(v.x-450)) + 320;
       [self display];
       v.y = (v.x)+1;
       np = (np==0)?1:0; 
    }
    vuela=0; 
}  

- (void)circulos:(id)sender
{
    vuela  = np = 0; 
    if (running) {
        [pajaritoTimer invalidate];
        [pajaritoTimer release];
        running = NO;
    } else {
        pajaritoTimer = [[NSTimer scheduledTimerWithTimeInterval:0.2 
              target:self selector:@selector(animate:) userInfo:nil 
              repeats:YES] retain];
        running = YES;
    }
}

- (void)animate:(NSTimer *)timer {
    np = (np==0)? 1 : 0; 
    [self display];
    [self lockFocus]; 
    v.x = cos(theta)*RADIO + 250; 
    v.y = sin(theta)*RADIO + 190;    
    theta+=.08; 
    [pajarito[np] compositeToPoint:v operation: NSCompositeXOR]; 
    [[self window] flushWindow];
    [self unlockFocus];
}
@end
